#include <gsl/gsl_fit.h>

int linear(double* c0, double* c1, double* chi_sq,
	   double* cov00, double* cov01, double* cov11,
	   int xs, const double* x, int ys, const double* y)
{
  if (xs != ys) return 2000; //BAD_SIZE
  
  return gsl_fit_linear(x,1,y,1,xs,c0,c1,cov00,cov01,cov11,chi_sq);
}

int linear_weighted(double* c0, double* c1, double* chi_sq,
		    double* cov00, double* cov01, double* cov11,
		    int xs, const double* x, 
		    int ws, const double * w, 
		    int ys, const double* y)
{
  if (xs != ys || xs != ws) return 2000; //BAD_SIZE
  
  return gsl_fit_wlinear(x,1,w,1,y,1,xs,c0,c1,cov00,cov01,cov11,chi_sq);
}


int linear_estimate(double x, double c0, double c1, 
		    double cov00, double cov01, double cov11,
		    double* y, double* e)
{
  return gsl_fit_linear_est(x,c0,c1,cov00,cov01,cov11,y,e);
}
